'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _assert = require('assert');

var assert = _interopRequireWildcard(_assert);

var _enumify = require('../lib/enumify');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global test */
/* global suite */

//-------------------------------------------------
suite('Simple');

var Color = function (_Enum) {
    _inherits(Color, _Enum);

    function Color() {
        _classCallCheck(this, Color);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(Color).apply(this, arguments));
    }

    return Color;
}(_enumify.Enum);

Color.initEnum(['RED', 'GREEN', 'BLUE']);

test('instanceof', function () {
    assert.ok(Color.RED instanceof Color);
});

test('toString', function () {
    assert.strictEqual(String(Color.RED), 'Color.RED');
});

test('ordinal', function () {
    assert.strictEqual(Color.GREEN.ordinal, 1);
});
test('enumValueOf', function () {
    assert.strictEqual(Color.enumValueOf('BLUE'), Color.BLUE);
});
test('enumValues', function () {
    assert.deepStrictEqual(Color.enumValues, [Color.RED, Color.GREEN, Color.BLUE]);
});
test('Closed constructor', function () {
    assert.throws(function () {
        new Color();
    });
});

//-------------------------------------------------
suite('Custom constructor and instance method');

var TicTacToeColor = function (_Enum2) {
    _inherits(TicTacToeColor, _Enum2);

    function TicTacToeColor() {
        _classCallCheck(this, TicTacToeColor);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(TicTacToeColor).call(this));
    }

    return TicTacToeColor;
}(_enumify.Enum);

TicTacToeColor.initEnum({
    O: new TicTacToeColor().override({
        invert: function invert() {
            return TicTacToeColor.X;
        }
    }),
    X: new TicTacToeColor().override({
        invert: function invert() {
            return TicTacToeColor.O;
        }
    })
});

test('Custom instance method', function () {
    assert.strictEqual(TicTacToeColor.X.invert(), TicTacToeColor.O);
});
test('toString', function () {
    assert.strictEqual(String(TicTacToeColor.O), 'TicTacToeColor.O');
});
test('ordinal', function () {
    assert.strictEqual(TicTacToeColor.O.ordinal, 0);
    assert.strictEqual(TicTacToeColor.X.ordinal, 1);
});

//-------------------------------------------------
suite('Custom prototype method');

var Weekday = function (_Enum3) {
    _inherits(Weekday, _Enum3);

    function Weekday() {
        _classCallCheck(this, Weekday);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(Weekday).apply(this, arguments));
    }

    _createClass(Weekday, [{
        key: 'isBusinessDay',
        value: function isBusinessDay() {
            switch (this) {
                case Weekday.SATURDAY:
                case Weekday.SUNDAY:
                    return false;
                default:
                    return true;
            }
        }
    }]);

    return Weekday;
}(_enumify.Enum);

Weekday.initEnum(['MONDAY', 'TUESDAY', 'WEDNESDAY', 'THURSDAY', 'FRIDAY', 'SATURDAY', 'SUNDAY']);
test('Custom prototype method', function () {
    assert.strictEqual(Weekday.SATURDAY.isBusinessDay(), false);
    assert.strictEqual(Weekday.MONDAY.isBusinessDay(), true);
});
